-----------------------------------------------------------------------------------------------
-- Client Lua Script for Darkie
-- Copyright (c) NCsoft. All rights reserved
-- Version 1.1
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- Darkie Module Definition
-----------------------------------------------------------------------------------------------
local Darkie = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
local Showme = true

 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Darkie:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Darkie:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
	Apollo.RegisterEventHandler("ChangeWorld", "OnChangeWorld", self)
	
end
 
-----------------------------------------------------------------------------------------------
-- Darkie OnLoad
-----------------------------------------------------------------------------------------------
function Darkie:OnLoad()
    -- load our form file
	Apollo.RegisterSlashCommand("darkie", "OnDarkieOn", self)
	self.wndMain = Apollo.LoadForm("Darkie.xml","DarkieForm",nil,self)
	self.wndMain:Show(false)
end

-----------------------------------------------------------------------------------------------
-- Darkie Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

function Darkie:OnChangeWorld()

	if HousingLib:IsHousingWorld() == true then
		if Showme == true then
			self.wndMain:Show(true)
			Showme = false
		end
	else
		Showme = true
	end

end

-- on SlashCommand "/dark"
function Darkie:OnDarkieOn()
	self.wndMain:Show(true)
end


-----------------------------------------------------------------------------------------------
-- DarkieForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function Darkie:OnOK()
	local neighborList=HousingLib.GetNeighborList()
    for i=1,#neighborList do
        if neighborList[i].strCharacterName == "DarkWabo" then
            --ChatSystemLib.PostOnChannel(2,"DarkMight is " .. neighborList[i].nId .. ".")
			HousingLib.VisitNeighborResidence(neighborList[i].nId)
        end
    end

	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function Darkie:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- Darkie Instance
-----------------------------------------------------------------------------------------------
local DarkieInst = Darkie:new()
DarkieInst:Init()
